#include <windows.h>
#include <stdlib.h>
#include <dos.h>
#define STATIC_WINDOW_NAME "Dimke Fake Date"
#define MIN_SEKUNDEN 1
#define STD_SEKUNDEN 10
#define MAX_SEKUNDEN 600
#define TIMER_BLINK 1
#define TIMER_BLINK_MS 500
#define TIMER_WARTE 2
#define TIMER_WARTE_MS 2000
#define JAHR_GESETZT 2001

#define WINDOW_CX 300
#define WINDOW_CY 45
#define WINDOW_X (GetSystemMetrics(SM_CXSCREEN) - WINDOW_CX) // Rechtsbndig
#define WINDOW_Y 0

LONG FAR PASCAL WndProc (HWND , UINT , UINT , LONG) ;
LONG FAR PASCAL TimerHdl (HWND) ;
BOOL FAR PASCAL _export AboutDlgProc(HWND, UINT, UINT, LONG);
BOOL exit_flag=FALSE;
unsigned int anz_sekunden;
unsigned int jahr_differenz;
struct date d, d_temp;
char fenstertitel[100];

int PASCAL WinMain (HANDLE hInstance , HANDLE hPrevInstance , LPSTR lpszCmdParam , int nCmdShow){
	MSG msg ;
	HWND hwnd, hwnd_static, hwnd_focus;
	WNDCLASS wndclass, wndclass_hidden;
	if (!hPrevInstance){
		wndclass.style = CS_HREDRAW | CS_VREDRAW ;
		wndclass.lpfnWndProc = WndProc ;
		wndclass.cbClsExtra = 0 ;
		wndclass.cbWndExtra = 0 ;
		wndclass.hInstance = hInstance ;
		wndclass.hIcon = LoadIcon (hInstance, "CLOCK") ;
		wndclass.hCursor = LoadCursor (NULL , IDC_ARROW) ;
		wndclass.hbrBackground = GetStockObject (LTGRAY_BRUSH) ;
		wndclass.lpszMenuName = "MAINMENU" ;
		wndclass.lpszClassName = "WndClassName" ;
		RegisterClass (&wndclass) ;

		wndclass_hidden.style = 0;
		wndclass_hidden.lpfnWndProc = WndProc ;
		wndclass_hidden.cbClsExtra = 0 ;
		wndclass_hidden.cbWndExtra = 0 ;
		wndclass_hidden.hInstance = hInstance ;
		wndclass_hidden.hIcon = LoadIcon (NULL, IDI_APPLICATION) ;
		wndclass_hidden.hCursor = LoadCursor (NULL , IDC_ARROW) ;
		wndclass_hidden.hbrBackground = GetStockObject (LTGRAY_BRUSH) ;
		wndclass_hidden.lpszMenuName = NULL;
		wndclass_hidden.lpszClassName = "WndClassName_hidden" ;
		RegisterClass (&wndclass_hidden) ;
	}

	if (FindWindow(NULL, STATIC_WINDOW_NAME)) {
//		MessageBox(NULL, "Already one instance of this process running!", "Process already running!", MB_OK | MB_ICONSTOP);
		return(1);
	}

	hwnd_static = CreateWindow ("WndClassName_hidden",STATIC_WINDOW_NAME,WS_OVERLAPPEDWINDOW,0,0,0,0,
		NULL,NULL,hInstance,NULL);

	/* We create a window so we can close it, but we are not invoking the ShowWindow command. */
	/* The program runs and does not need a menu or dialog boxes, and so does not comsume any */
	/* of our valuable GDI resources. So look here:                                           */

//	ShowWindow (hwnd , nCmdShow) ;
//	UpdateWindow (hwnd) ;

	hwnd_focus=GetFocus();

	hwnd = CreateWindow ("WndClassName" ,  NULL , WS_OVERLAPPEDWINDOW , WINDOW_X, WINDOW_Y ,
			WINDOW_CX, WINDOW_CY, NULL , NULL , hInstance , NULL) ;

	ShowWindow (hwnd , nCmdShow) ;
	UpdateWindow (hwnd) ;

	SetWindowPos(hwnd, HWND_TOPMOST, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);

	getdate(&d);
	jahr_differenz=d.da_year-JAHR_GESETZT;
	d.da_year=JAHR_GESETZT;
	setdate(&d);
	getdate(&d_temp);
	if(d.da_year!=d_temp.da_year){
		MessageBox(NULL, "Date could not be set.\n\nPossible reason: Insufficient user rights", "Fatal Error", MB_OK | MB_ICONSTOP);
		return -1;
	}

	anz_sekunden=atoi(lpszCmdParam);
	if(anz_sekunden < MIN_SEKUNDEN) anz_sekunden=STD_SEKUNDEN;
	if(anz_sekunden > MAX_SEKUNDEN) anz_sekunden=MAX_SEKUNDEN;

	SetFocus(hwnd_focus);

	SetTimer(hwnd, TIMER_BLINK, TIMER_BLINK_MS, 0);

	TimerHdl (hwnd);

	while (GetMessage (&msg , NULL ,0 ,0)){
		TranslateMessage (&msg) ;
		DispatchMessage (&msg) ;
	}
	return msg.wParam ;
}

LONG FAR PASCAL WndProc (HWND hwnd , UINT message , UINT wParam , LONG lParam) {
static FARPROC lpfnAboutDlgProc;
static HANDLE  hInstance;

	switch (message){
		case WM_CREATE:
			hInstance = ((LPCREATESTRUCT) lParam)->hInstance;
			lpfnAboutDlgProc = MakeProcInstance ((FARPROC) AboutDlgProc, hInstance);
			return 0;

		case WM_COMMAND:
			if (wParam == 100) // Help => about
				DialogBox(hInstance, "ABOUT", hwnd, lpfnAboutDlgProc);

			if (wParam == 110) // Exit
				SendMessage(hwnd, WM_CLOSE, 0, 0L);

			return 0;

		case WM_TIMER:	{
				if(wParam==TIMER_BLINK){
					TimerHdl (hwnd);
				}
				if(wParam==TIMER_WARTE){
					PostQuitMessage(0);
				}
		}
		break;

		case WM_CLOSE:	{
			if(!exit_flag){
				exit_flag=TRUE;
				KillTimer(hwnd, TIMER_BLINK);
				getdate(&d);
				d.da_year+=jahr_differenz;
				setdate(&d);
				getdate(&d_temp);
				if(d.da_year!=d_temp.da_year){
					MessageBox(NULL, "Date could not be set.\n\nPossible reason: Insufficient user rights", "Fatal Error", MB_OK | MB_ICONSTOP);
					return -1;
				}
				wsprintf(fenstertitel, "Date reset to %02d.%02d.%d",d.da_day, d.da_mon, d.da_year);
				SetWindowText(hwnd,fenstertitel);
				SetTimer(hwnd, TIMER_WARTE, TIMER_WARTE_MS, 0);
			}
		}
		return 0 ;
	}
	return DefWindowProc (hwnd , message , wParam , lParam) ;
}

LONG FAR PASCAL TimerHdl (HWND hwnd) {
static unsigned int zaehler=anz_sekunden+1;
static BOOL blinkflag=0;

	if(zaehler==0) {
			SendMessage(hwnd, WM_CLOSE, 0, 0L);
			return 0;
	}

	blinkflag=!blinkflag;

	if(blinkflag) {
		zaehler--;
		wsprintf(fenstertitel, "Date modified - %3d seconds left ", zaehler);
		}
	else {
		wsprintf(fenstertitel, " ");
	}
	SetWindowText(hwnd, fenstertitel);
}

BOOL FAR PASCAL _export AboutDlgProc (HWND hDlg, UINT message, UINT wParam, LONG lParam) {
	switch(message) {
		case WM_INITDIALOG:
			return TRUE;

		case WM_COMMAND:
			switch(wParam) {
				case IDOK:
				case IDCANCEL:
					EndDialog(hDlg, 0);
					return TRUE;
			}
			break;
	}
	return FALSE;
}
